summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2008-01-06 12:38:18 +0100
committerJim Meyering <meyering@redhat.com>2008-01-06 12:50:54 +0100
commit9b76bc2b54180caa80afed4d88377ddd0f0ab6de (patch)
tree79dcdba6b017cb179c2844151a7cc220d2b13405 /tests
parentfd12e98f36bdea018227909378f1adac8e1e1e6f (diff)
downloadcoreutils-9b76bc2b54180caa80afed4d88377ddd0f0ab6de.tar.xz
touch: add a test for today's change.
* tests/touch/now-owned-by-other: New script. Test today's change. * tests/touch/Makefile.am (TESTS): Add now-owned-by-other. * tests/Makefile.am (all_t): Add td, a new root-only test. (td): New target. * NEWS: Mention the improvement.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am4
-rw-r--r--tests/touch/Makefile.am3
-rwxr-xr-xtests/touch/now-owned-by-other40
3 files changed, 45 insertions, 2 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 2db18f02a..25ca50911 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -48,7 +48,7 @@ SUBDIRS = \
uniq wc
## N O T E :: Please do not add new directories.
-all_t = t1 t2 t3 t4 t5 t6 t7 t8 t9 ta tb tc
+all_t = t1 t2 t3 t4 t5 t6 t7 t8 t9 ta tb tc td
.PHONY: check-root $(all_t)
check-root: $(all_t)
@@ -76,6 +76,8 @@ tb:
cd mv && $(MAKE) check TESTS=sticky-to-xpart
tc:
cd cp && $(MAKE) check TESTS=preserve-gid
+td:
+ cd touch && $(MAKE) check TESTS=now-owned-by-other
check-recursive: root-hint
diff --git a/tests/touch/Makefile.am b/tests/touch/Makefile.am
index d17213d39..8d90cbaca 100644
--- a/tests/touch/Makefile.am
+++ b/tests/touch/Makefile.am
@@ -1,6 +1,6 @@
# Make coreutils tests for "touch". -*-Makefile-*-
-# Copyright (C) 1998-2007 Free Software Foundation, Inc.
+# Copyright (C) 1998-2008 Free Software Foundation, Inc.
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
@@ -16,6 +16,7 @@
# along with this program. If not, see <http://www.gnu.org/licenses/>.
TESTS = \
+ now-owned-by-other \
read-only \
relative \
not-owner \
diff --git a/tests/touch/now-owned-by-other b/tests/touch/now-owned-by-other
new file mode 100755
index 000000000..0871ff7de
--- /dev/null
+++ b/tests/touch/now-owned-by-other
@@ -0,0 +1,40 @@
+#!/bin/sh
+# Demonstrate that "touch -d now writable-but-owned-by-other" works.
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ touch --version
+fi
+
+. $srcdir/../envvar-check
+PRIV_CHECK_ARG=require-root . $srcdir/../priv-check
+. $srcdir/../test-lib.sh
+
+group_num=$(id -g $NON_ROOT_USERNAME)
+
+# Create a file owned by root, and writable by $NON_ROOT_USERNAME.
+echo > root-owned || framework_failure
+chgrp +$group_num . root-owned || framework_failure
+chmod g+w root-owned
+
+# Ensure that the current directory is searchable by $NON_ROOT_USERNAME.
+chmod g+x .
+
+setuidgid $NON_ROOT_USERNAME env PATH="$PATH" touch -d now root-owned || fail=1
+
+(exit $fail); exit $fail